﻿function toggleNode(sender)
{
    var fl = $(sender).siblings('div:first').toggle().is(':visible');
    var src = ''+ (fl?'minus_12x12.bmp':'plus_12x12.bmp');
    var alt = (fl?'[-]':'[+]');
    $(sender).find('img').attr('src', src).attr('alt',alt);
    return false;
}

function data2tree(data)
{
    function add2tree(tree,keys,value)
    {
      if( typeof tree=="undefined" )
         tree={};
      if( keys.length==1 )
         tree[keys[0]]=value
      else
         tree[keys[0]]=add2tree(tree[keys[0]],keys.slice(1),value);
      return tree;
    }
    var tree = {};
    for( var idx in data )
        add2tree(tree,data[idx].path,idx);
    return tree;
}

function tree2html(tree,level,makeLeaf)
{
    html = "";
    for( var k in tree )
    {
        html = html + '<div>';
        if(typeof tree[k]=="object")
            html=html   + '<a href="#" class="branch lv_'+level+'" onclick="return toggleNode(this)">'+k+'</a>'
                        + '<div class="node">'+tree2html(tree[k],level+1,makeLeaf)+'</div>'
        else
            html = html + makeLeaf(k,tree[k]);
        html = html + '</div>';
    }
    return html;
}
